Public Class LaborEinzelWertControl
    Implements ILaborWertControl

    Private WithEvents m_Source As LaborTextGruppeEinzelWert
    Private WithEvents m_DescrLabel As Label
    Private m_Controls As New List(Of LaborWertEinzelControl)
    Private WithEvents m_ColLbl As ColorLabel

    Private WithEvents m_ButtonMoveLeft As MoveButton
    Private WithEvents m_ButtonMoveRight As MoveButton


    Private WithEvents m_ButtonMoveUp As MoveButton
    Private WithEvents m_ButtonMoveDown As MoveButton
    Private m_Panel As LaborPanel

    Private WithEvents m_SelectedControl As LaborWertEinzelControl

    WriteOnly Property Panel() As LaborPanel Implements ILaborWertControl.Panel
        Set(ByVal value As LaborPanel)
            m_Panel = value
        End Set
    End Property
    ReadOnly Property Source() As LaborTextGruppe Implements ILaborWertControl.Source
        Get
            Return m_Source
        End Get
    End Property
    Public Sub New(ByVal Source As LaborTextGruppeEinzelWert)

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        m_ColLbl = New ColorLabel()
        m_ColLbl.Dock = DockStyle.Top
        m_ColLbl.Text = m_Source.Title

        m_DescrLabel = New Label
        m_DescrLabel.Text = "normal"
        m_DescrLabel.AutoSize = False
        m_DescrLabel.Height = 14
        m_DescrLabel.TextAlign = ContentAlignment.TopRight
        m_DescrLabel.Dock = DockStyle.Top

        For Each Wt As LaborWert In m_Source.Werte
            Dim Ctl As New LaborWertEinzelControl(Wt)
            Ctl.Dock = DockStyle.Top
            m_Controls.Add(Ctl)
            AddHandler Ctl.Label_Clicked, AddressOf SelControl_Label_Clicked
        Next
        m_Controls(m_Controls.Count - 1).Height += 1

        m_Controls.Reverse()
        Dim TmpHeight As Integer = m_Controls.Count * 19 + 1 + m_DescrLabel.Height + m_ColLbl.Height
        Me.Size = New Size(120, TmpHeight)
        Me.Controls.AddRange(m_Controls.ToArray)
        Me.Controls.Add(m_DescrLabel)
        Me.Controls.Add(m_ColLbl)
        m_Controls.Reverse()
        Me.DoubleBuffered = True
        TabStoppsSortieren()
    End Sub

    Private Sub m_ColLbl_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ColLbl.Click
        LoadInternButtons()
    End Sub
    Private Sub LoadInternButtons()
        m_ColLbl.BackColor = Color.Red
        If m_ButtonMoveLeft IsNot Nothing Then
            Me.Controls.Remove(m_ButtonMoveLeft)
            Me.Controls.Remove(m_ButtonMoveRight)
            m_ButtonMoveLeft = Nothing
            m_ButtonMoveRight = Nothing
        End If

        m_ButtonMoveLeft = New MoveButton(MoveDirections.Left, m_Source)
        m_ButtonMoveRight = New MoveButton(MoveDirections.Right, m_Source)
        m_ButtonMoveLeft.Location = New Point(Me.Width - 32, 0)
        m_ButtonMoveRight.Location = New Point(Me.Width - 16, 0)

        Me.Controls.Add(m_ButtonMoveLeft)
        Me.Controls.Add(m_ButtonMoveRight)
        m_ButtonMoveLeft.BringToFront()
        m_ButtonMoveRight.BringToFront()
        UnLoadUpDownButtons()
        m_Panel.SetButtonsEnabled(Me, Nothing)
    End Sub
    Private Sub UnLoadInternButtons()
        m_ColLbl.BackColor = Color.Teal
        If m_ButtonMoveLeft IsNot Nothing Then
            Me.Controls.Remove(m_ButtonMoveLeft)
            Me.Controls.Remove(m_ButtonMoveRight)
            m_ButtonMoveLeft = Nothing
            m_ButtonMoveRight = Nothing
        End If
    End Sub

    Private Sub m_ColLbl_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ColLbl.Leave
        UnLoadInternButtons()
    End Sub
    Private m_InternFocusChange As Boolean = False
    Public Sub RefreshButtons() Implements ILaborWertControl.RefreshButtons
        If m_ButtonMoveLeft IsNot Nothing Then
            m_InternFocusChange = True
            m_ButtonMoveLeft.Enabled = m_Source.CanMoveUp
            m_ButtonMoveRight.Enabled = m_Source.CanMoveDown
            If Not m_ButtonMoveLeft.Enabled Then
                If m_ButtonMoveRight.Enabled Then
                    m_ButtonMoveRight.Focus()
                End If
            ElseIf Not m_ButtonMoveRight.Enabled Then
                If m_ButtonMoveLeft.Enabled Then
                    m_ButtonMoveLeft.Focus()
                End If
            End If
            m_InternFocusChange = False
        End If
    End Sub
    Private Sub RefreshUpDownButtons()
        If m_ButtonMoveUp IsNot Nothing Then
            m_InternFocusChangeUpDown = True

            m_ButtonMoveUp.Enabled = m_SelectedControl.Source.CanMoveUp
            m_ButtonMoveDown.Enabled = m_SelectedControl.Source.CanMoveDown
            If Not m_ButtonMoveUp.Enabled Then
                If m_ButtonMoveDown.Enabled Then
                    m_ButtonMoveDown.Focus()
                End If
            ElseIf Not m_ButtonMoveDown.Enabled Then
                If m_ButtonMoveUp.Enabled Then
                    m_ButtonMoveUp.Focus()
                End If
            End If
            m_InternFocusChangeUpDown = False
        End If
    End Sub



    Private Sub m_ButtonMoveLeft_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ButtonMoveLeft.LostFocus
        If m_InternFocusChange = True Then Exit Sub
        If Not m_ButtonMoveRight.Focused Then
            UnLoadInternButtons()
        End If
    End Sub
    Private Sub m_ButtonMoveRight_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ButtonMoveRight.LostFocus
        If m_InternFocusChange = True Then Exit Sub

        If Not m_ButtonMoveLeft.Focused Then
            UnLoadInternButtons()
        End If
    End Sub

    Private Sub SelControl_Label_Clicked(ByVal sender As LaborWertEinzelControl)
        If m_SelectedControl IsNot sender Then
            m_SelectedControl = sender
            SetUpDownButtons()
            UnLoadInternButtons()
            m_Panel.SetButtonsEnabled(Me, sender)
        End If
    End Sub

    Private Sub SetUpDownButtons()
        If (m_ButtonMoveUp IsNot Nothing AndAlso m_SelectedControl Is Nothing) OrElse (m_ButtonMoveUp IsNot Nothing AndAlso m_SelectedControl.Source IsNot m_ButtonMoveUp.ClassToMove) Then
            Me.Controls.Remove(m_ButtonMoveUp)
            Me.Controls.Remove(m_ButtonMoveDown)
            m_ButtonMoveUp = Nothing
            m_ButtonMoveDown = Nothing
        End If
        If m_SelectedControl IsNot Nothing Then
            m_ButtonMoveUp = New MoveButton(MoveDirections.Up, m_SelectedControl.Source)
            m_ButtonMoveDown = New MoveButton(MoveDirections.Down, m_SelectedControl.Source)
            Me.Controls.Add(m_ButtonMoveUp)
            Me.Controls.Add(m_ButtonMoveDown)

        End If
        RefreshUpDownButtonPositions()

        '  Private WithEvents m_ButtonMoveUp As MoveButton
        'Private WithEvents m_ButtonMoveDown As MoveButton
    End Sub
    Private Sub RefreshUpDownButtonPositions()
        If m_ButtonMoveUp IsNot Nothing Then
            m_ButtonMoveUp.Top = m_SelectedControl.Top - 10
            m_ButtonMoveDown.Top = m_SelectedControl.Bottom - 2
            m_ButtonMoveUp.BringToFront()
            m_ButtonMoveDown.BringToFront()
        End If
    End Sub

    Private m_InternFocusChangeUpDown As Boolean = False

    Private Sub m_SelectedControl_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_SelectedControl.Leave
        UnLoadUpDownButtons()
    End Sub


    Private Sub m_ButtonMoveDown_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ButtonMoveDown.LostFocus
        If m_InternFocusChangeUpDown Then Exit Sub
        If Not m_ButtonMoveUp.Focused Then
            UnLoadUpDownButtons()
        End If
    End Sub

    Private Sub m_ButtonMoveUp_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ButtonMoveUp.LostFocus
        If m_InternFocusChangeUpDown Then Exit Sub
        If Not m_ButtonMoveDown.Focused Then
            UnLoadUpDownButtons()
        End If
    End Sub
    Private Sub UnLoadUpDownButtons()
        If m_ButtonMoveUp IsNot Nothing Then
            Me.Controls.Remove(m_ButtonMoveUp)
            Me.Controls.Remove(m_ButtonMoveDown)
            m_ButtonMoveUp = Nothing
            m_ButtonMoveDown = Nothing
            m_SelectedControl = Nothing
        End If
    End Sub
    'Public Sub HideButtons() Implements ILaborWertControl.HideButtons
    '    UnLoadInternButtons()
    'End Sub


    Private Sub m_Source_Changed() Handles m_Source.Changed
        MyBase.SuspendLayout()
        m_InternFocusChange = True
        m_InternFocusChangeUpDown = True

        If m_ButtonMoveUp IsNot Nothing Then
            Me.Controls.Remove(m_ButtonMoveUp)
            Me.Controls.Remove(m_ButtonMoveDown)
        End If

        Dim ControlsToRemove As New List(Of Control)
        Dim ControlsToAdd As New List(Of Control)
        Dim KnownWerte As New List(Of LaborWert)

        For Each Ctl As LaborWertEinzelControl In m_Controls

            If Not m_Source.Werte.Contains(Ctl.Source) Then
                ControlsToRemove.Add(Ctl)
                RemoveHandler Ctl.Label_Clicked, AddressOf SelControl_Label_Clicked
            Else
                KnownWerte.Add(Ctl.Source)
            End If
        Next


        For Each Ctl As Control In ControlsToRemove
            Me.Controls.Remove(Ctl)
            m_Controls.Remove(Ctl)
        Next
        For Each Wt As LaborWert In m_Source.Werte
            If Not KnownWerte.Contains(Wt) Then
                Dim Ctl As New LaborWertEinzelControl(Wt)
                Ctl.Dock = DockStyle.Top
                ControlsToAdd.Add(Ctl)
                m_Controls.Add(Ctl)
                AddHandler Ctl.Label_Clicked, AddressOf SelControl_Label_Clicked
            End If
        Next


        For Each Ctl As Control In ControlsToAdd
            Me.Controls.Add(Ctl)
        Next

        m_Controls.Sort(New LaborWertEinzelControlComparer(m_Source))


        For Each Ctl As LaborWertEinzelControl In m_Controls
            Me.Controls.SetChildIndex(Ctl, 0)
            Ctl.Height = 19
        Next

        m_Controls(m_Controls.Count - 1).Height = 20

        MyBase.ResumeLayout()
        Me.Height = m_Controls(m_Controls.Count - 1).Top + m_Controls(m_Controls.Count - 1).Height

        If m_ButtonMoveUp IsNot Nothing Then
            Me.Controls.Add(m_ButtonMoveUp)
            Me.Controls.Add(m_ButtonMoveDown)
            m_ButtonMoveUp.BringToFront()
            m_ButtonMoveDown.BringToFront()
        End If

        RefreshUpDownButtonPositions()
        m_InternFocusChange = False
        m_InternFocusChangeUpDown = False

        If m_ButtonMoveUp IsNot Nothing Then
            If Not m_Source.Werte.Contains(m_ButtonMoveUp.ClassToMove) Then
                Me.Controls.Remove(m_ButtonMoveUp)
                Me.Controls.Remove(m_ButtonMoveDown)
                m_ButtonMoveUp = Nothing
                m_ButtonMoveDown = Nothing
            End If
        End If


        RefreshButtons()
        RefreshUpDownButtons()
        TabStoppsSortieren()
    End Sub


   
    Private Sub TabStoppsSortieren()
        Dim Zaehler As Integer = Me.Controls.Count

        For Each Ctl As Control In Me.Controls
            Ctl.TabIndex = Zaehler
            Zaehler -= 1
        Next
    End Sub

    Public Sub HideButtons(ByVal ParentControl As System.Windows.Forms.Control, ByVal ChildControl As System.Windows.Forms.Control) Implements ILaborWertControl.HideButtons
        If ChildControl IsNot Nothing Then

            If ChildControl.GetType IsNot m_Controls(0).GetType Then
                UnLoadUpDownButtons()
            Else
                If Not m_Controls.Contains(ChildControl) Then
                    UnLoadUpDownButtons()
                End If
            End If
        Else
            If ParentControl IsNot Me Then
                UnLoadInternButtons()
            End If
        End If
    End Sub
End Class
