Public Class LaborWertEinzelControl
    Private m_Source As LaborWert
    Private m_Initialising As Boolean = False

    Private m_Highlight As Boolean = False
    Public Event Highlight_Changed()
    Public Event Label_Clicked(ByVal Sender As LaborWertEinzelControl)

    ReadOnly Property Source() As LaborWert
        Get
            Return m_Source
        End Get
    End Property
    ReadOnly Property Highlight() As Boolean
        Get
            Return m_Highlight
        End Get
    End Property

    Public Sub New(ByVal Source As LaborWert)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Me.Label1.Text = m_Source.Kuerzel
        m_Initialising = True
        If m_Source.Wert = "ok" Then
            Me.CheckBox1.Checked = True
            Me.TextBox1.Enabled = False
        Else
            Me.CheckBox1.Checked = False
            Me.TextBox1.Enabled = True
            Me.TextBox1.Text = m_Source.Wert
        End If
        m_Initialising = False
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If m_Initialising Then Exit Sub

        If Me.TextBox1.Text.Trim = "" Then
            Me.TextBox1.ForeColor = Color.Black
            m_Source.Wert = ""
        Else
            Try
                Dim Wert As Single = CSng(TextBox1.Text.Trim)
                m_Source.Wert = TextBox1.Text.Trim
                Me.TextBox1.ForeColor = Color.Black
            Catch ex As Exception
                Me.TextBox1.ForeColor = Color.Red
            End Try
        End If


    End Sub
    Private Sub TextBox1_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox1.Validating
        m_Source.Gruppe.ReCreateText()
    End Sub
    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If m_Initialising Then Exit Sub

        m_Initialising = True

        If CheckBox1.Checked Then
            m_Source.Wert = "ok"
            Me.TextBox1.Enabled = False
        Else
            m_Source.Wert = ""
            Me.TextBox1.Enabled = True
        End If

        Me.TextBox1.Text = ""
        'Me.TextBox1.ForeColor = Color.Black
        'Me.TextBox1.BackColor = SystemColors.Window
        m_Source.Gruppe.ReCreateText()
        m_Initialising = False
    End Sub

    Private Sub Label1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label1.Click
        RaiseEvent Label_Clicked(Me)
    End Sub


    Private Sub Label1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label1.MouseEnter
        Me.Label1.ForeColor = Color.Red
        m_Highlight = True
        RaiseEvent Highlight_Changed()
    End Sub

    Private Sub Label1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label1.MouseLeave
        Me.Label1.ForeColor = Color.Black
        m_Highlight = False
        RaiseEvent Highlight_Changed()
    End Sub
End Class
