Imports System.Xml
Public MustInherit Class LaborTextGruppe
    Implements Imovable
    Private m_Title As String
    Private m_Werte As New List(Of LaborWert)
    Private m_Builder As LaborTextBuilder

    Private m_WasChanged As Boolean = False
    ReadOnly Property Builder() As LaborTextBuilder
        Get
            Return m_Builder
        End Get
    End Property
    Property WasChanged() As Boolean
        Get
            Return m_WasChanged
        End Get
        Set(ByVal value As Boolean)
            m_WasChanged = value
        End Set
    End Property
    Private m_IsMovedGroup As Boolean = False
    Property IsMovedGroup() As Boolean Implements Imovable.IsMovedGroup
        Get
            Return m_IsMovedGroup
        End Get
        Set(ByVal value As Boolean)
            m_IsMovedGroup = value
        End Set
    End Property

    Public Event Changed()
    Public Sub RaiseChanged()
        RaiseEvent Changed()
    End Sub

    Public Event TextValidation()
    Public Sub ReCreateText()
        RaiseEvent TextValidation()
        m_Builder.CreateText()
    End Sub


    ReadOnly Property Werte() As List(Of LaborWert)
        Get
            Return m_Werte
        End Get
    End Property
    ReadOnly Property Title() As String
        Get
            Return m_Title
        End Get
    End Property
    Public Sub New(ByVal Title As String, ByVal Builder As LaborTextBuilder)
        m_Title = Title
        m_Builder = Builder
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Dim FoundWerte As New List(Of LaborWert)
        For Each Wrt As LaborWert In m_Werte
            If Wrt.Wert <> "" Then
                FoundWerte.Add(Wrt)
            End If
        Next

        Dim Unauffaellig As Boolean = IstUnauffaellig()

        If FoundWerte.Count > 0 OrElse Unauffaellig Then
            Writer.WriteStartElement(m_Title)
            If Unauffaellig Then Writer.WriteAttributeString("Unauffaellig", Unauffaellig.ToString)
            For Each Wrt As LaborWert In FoundWerte
                Writer.WriteAttributeString(Wrt.Kuerzel, Wrt.Wert)
            Next
            Writer.WriteEndElement()
        End If
    End Sub

    MustOverride Function IstUnauffaellig() As Boolean
    MustOverride Sub SetUnauffaellig(ByVal Value As Boolean)

    Public Sub SetValues(ByVal Nd As XmlNode)
        Dim TmpWerte As New List(Of LaborWert)

        Dim DicWerte As New Dictionary(Of String, LaborWert)
        For Each Wrt As LaborWert In m_Werte
            TmpWerte.Add(Wrt)
            DicWerte.Add(Wrt.Kuerzel, Wrt)
        Next
        m_Werte.Clear()
        For Each att As XmlAttribute In Nd.Attributes
            If att.Name = "Unauffaellig" Then
                SetUnauffaellig(True)
            Else
                Dim xWrt As LaborWert = DicWerte(att.Name)
                xWrt.Wert = att.Value
                m_Werte.Add(xWrt)
            End If
        Next
        For Each Wrt As LaborWert In TmpWerte
            If Not m_Werte.Contains(Wrt) Then
                m_Werte.Add(Wrt)
            End If
        Next

    End Sub


    Public Function CanMoveUp() As Boolean Implements Imovable.CanMoveUp
        If m_Builder.Gruppen.IndexOf(Me) = 0 Then
            Return False
        End If
        Return True
    End Function
    Public Function CanMoveDown() As Boolean Implements Imovable.CanMoveDown
        If m_Builder.Gruppen.IndexOf(Me) = m_Builder.Gruppen.Count - 1 Then
            Return False
        End If
        Return True
    End Function
    Public Sub MoveUp() Implements Imovable.MoveUp
        Dim Idx As Integer = m_Builder.Gruppen.IndexOf(Me)
        m_Builder.Gruppen.RemoveAt(Idx)
        m_Builder.Gruppen.Insert(Idx - 1, Me)
        m_Builder.RelocateDependendLaborWerte()
        m_Builder.RaiseChanged()
        m_Builder.RelocateDependendLaborWerte()
        m_Builder.RaiseGruppenChanges()
        m_Builder.CreateText()
    End Sub
    Public Sub MoveDown() Implements Imovable.MoveDown
        Dim Idx As Integer = m_Builder.Gruppen.IndexOf(Me)
        m_Builder.Gruppen.RemoveAt(Idx)
        m_Builder.Gruppen.Insert(Idx + 1, Me)
        m_Builder.RelocateDependendLaborWerte()
        m_Builder.RaiseChanged()
        m_Builder.RelocateDependendLaborWerte()
        m_Builder.RaiseGruppenChanges()
        m_Builder.CreateText()
    End Sub
    MustOverride Function CreateControl() As Control
    MustOverride Function NormalTexte() As List(Of String)
    MustOverride Function PathologischTexte() As List(Of String)

End Class
