Public MustInherit Class LaborTextGruppeGemeinsamWert
    Inherits LaborTextGruppe
    Private m_Unauffaellig As Boolean = False
    Property Unauffaellig() As Boolean
        Get
            Return m_Unauffaellig
        End Get
        Set(ByVal value As Boolean)
            m_Unauffaellig = value
        End Set
    End Property

    Public Sub New(ByVal Title As String, ByVal Builder As LaborTextBuilder)
        MyBase.New(Title, Builder)
    End Sub

    Public Overrides Function IstUnauffaellig() As Boolean
        Return m_Unauffaellig
    End Function

    Public Overrides Sub SetUnauffaellig(ByVal Value As Boolean)
        m_Unauffaellig = Value
        Builder.CreateText()
    End Sub

    Public Overrides Function CreateControl() As System.Windows.Forms.Control
        Return New LaborGemeinsamWertControl(Me)
    End Function

    MustOverride Function GetWeiteresLabel() As String
    Public Overrides Function NormalTexte() As System.Collections.Generic.List(Of String)
        Dim Result As New List(Of String)
        Dim SomethingPathologisch As Boolean = SomePathologisch()

        If Me.Unauffaellig Then
            If SomethingPathologisch Then
                Result.Add(GetWeiteresLabel)
            Else
                Result.Add(Me.Title)
            End If
        End If

        Return Result
    End Function
    Friend Function SomePathologisch() As Boolean
        For Each Wt As LaborWert In Me.Werte
            If Wt.Wert <> "" Then
                Return True
            End If
        Next
        Return False
    End Function
    Public Overrides Function PathologischTexte() As System.Collections.Generic.List(Of String)
        Dim Result As New List(Of String)
        For Each Wt As LaborWert In Me.Werte
            If Wt.Wert <> "" Then
                Result.Add(Wt.LangText & " " & Wt.Wert)
            End If
        Next
        Return Result
    End Function
End Class
